@echo off

cd /d %~dp0

setlocal ENABLEDELAYEDEXPANSION










set ARGUMENTS_BUFFER=
FOR %%a in ( %* ) do set ARGUMENTS_BUFFER=!ARGUMENTS_BUFFER!%%a 




set JARFILE=RinearnGraph3D.jar
set MEMORYFILE=RinearnGraph3DMemory.ini
set RE_COMMAND=
set RE_COMMAND_SEARCH=


goto :LOAD_MEMORY


:LOAD_MEMORY
SET MEMORYLINE=
IF EXIST %MEMORYFILE% (
	FOR /F "delims=" %%a IN (%MEMORYFILE%) DO (
		SET MEMORYLINE=%%a
		goto MEMORY_READ_END
	)
) ELSE (
	ECHO  - RINEARN Graph3D -
	ECHO ----------------------------------------------------------------------
	ECHO.
	ECHO   Welcome !
	ECHO.
	ECHO   Please input the memory allocation size [ MB ],
	ECHO   ande press Enter key.
	ECHO.
	ECHO   If you want to use the default setting,
	ECHO.  please Enter key without inputting anything.
	ECHO.
	ECHO ======================================================================
	ECHO.
	SET /P MEMORYLINE="Memory allocation size [ MB ] = "
	ECHO.
	ECHO The memory allocation size have set as the above.
	ECHO This setting is stored in the file folling file: %MEMORYFILE%
	ECHO.
	ECHO.
)

:MEMORY_READ_END

SET /A MEMORYLINE_NUM = MEMORYLINE + 0
IF NOT "%MEMORYLINE%"=="%MEMORYLINE_NUM%" (
	SET MEMORYLINE=DEFAULT
)

SET /A MEMORYLINE_NUM = MEMORYLINE + 0
IF "%MEMORYLINE%"=="%MEMORYLINE_NUM%" (
	SET MEMORYLINE= -Xmx%MEMORYLINE%m 
) ELSE (
	SET MEMORYLINE=  
)

goto :RE_TEST





:RE_TEST

::echo.
java -version 2> NUL
IF %ERRORLEVEL%==0 (
	set RE_COMMAND=java
	goto :RE_RUN
) else (
	goto :RE_SEARCH
)
goto :END





:RE_SEARCH

set RE_COMMAND_SEARCH="C:\Program Files\Java\jre12\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre12\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre11\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre11\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre10\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre10\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre9\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre9\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre8\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre8\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre7\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre7\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files\Java\jre6\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
set RE_COMMAND_SEARCH="C:\Program Files (x86)\Java\jre6\bin\java.exe"
if EXIST !RE_COMMAND_SEARCH! (
	set RE_COMMAND=!RE_COMMAND_SEARCH!
	goto :RE_FOUND
)
goto :RE_NOT_FOUND




:RE_FOUND
echo.
echo.
echo.
echo.
echo.
echo ==================================================
echo.
echo - java command is not available on this environment, 
echo.  but JRE is found in the following location.
echo.
echo.  * Oracle and Java are registered trademarks of Oracle and/or its affiliates. 
echo.
echo.
echo - Do you want to use the following JRE ? (y/n)
echo.
echo   [ The path of JRE ] !RE_COMMAND!
echo.
set /p pushKey="(Please enter y key for Yes, or n key for No) :%pushKey%"

if "%pushKey%"=="" (
	goto :RE_RUN
) else if "%pushKey%"=="y" (
	goto :RE_RUN
) else if "%pushKey%"=="yes" (
	goto :RE_RUN
) else if "%pushKey%"=="Yes" (
	goto :RE_RUN
) else if "%pushKey%"=="n" (
	goto :RE_NOT_RUN
) else if "%pushKey%"=="no" (
	goto :RE_NOT_RUN
) else if "%pushKey%"=="No" (
	goto :RE_NOT_RUN
)
goto :END



:RE_NOT_FOUND
echo ==================================================
echo.
echo - java command is not available on this environment,
echo.  and no JRE is found.
echo.
echo - To use this software, 
echo.  please install Java Runtime Environment(JRE).
echo.
echo   * Oracle and Java are registered trademarks of Oracle and/or its affiliates. 
echo.
cmd
goto :END



:RE_RUN
::echo.
::echo - Executing... 
::@ECHO ON
%RE_COMMAND%%MEMORYLINE%-jar %JARFILE% %ARGUMENTS_BUFFER%
::@ECHO OFF
goto :RE_SAVE



:RE_SAVE
IF %ERRORLEVEL%==0 (
	IF NOT EXIST %MEMORYFILE% (
		ECHO %MEMORYLINE_NUM%>>%MEMORYFILE%
		ECHO. >>%MEMORYFILE%
	)
) ELSE (
	ECHO.
	ECHO ======================================================================
	ECHO.
	ECHO - Failed to launch, or exited with errors.
	ECHO.
	ECHO.
	ECHO.
	ECHO.

	@ECHO OFF
	del %MEMORYFILE%
	@ECHO ON

	cmd
)
goto :END



:RE_NOT_RUN
echo.
echo - Exit.
echo.
cmd
goto :END








:END

